//main.m EPD
//Copyright James Marshall 1998-2002. Freely distributable under the GNU General Public Licence

#import "EPDDefines.h"
#ifdef observer
  #import "EPDObserverSwarm.h"
#else
  #import "EPDExperimentSwarm.h"
#endif
#import <simtools.h>

int main(int argc,const char **argv)
{
  id epdObserverSwarm;

  initSwarm(argc,argv);

  //make the model swarm
  #ifdef observer
    epdObserverSwarm=[EPDObserverSwarm create: globalZone];
  #else
    epdObserverSwarm=[EPDExperimentSwarm create: globalZone];
  #endif

  //send messages to swarm to create internal objects and activities
  [epdObserverSwarm buildObjects];
  [epdObserverSwarm buildActions];

  //activate the swarm
  [epdObserverSwarm activateIn: nil];

  //run the swarm
  [epdObserverSwarm go];
  return 0;
}
